"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.patchTsConfigCore = void 0;

var _tsconfig = require("../config/tsconfig");

var _deepmerge = _interopRequireDefault(require("deepmerge"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// @ts-check
const defaultDeps = Object.freeze({
  tsConfig: _tsconfig.tsConfig,
  tsConfigDeclarations: _tsconfig.tsConfigDeclarations
});
/**
 *
 * @param {{ oldConfig: {}, baseTsConfigLocation?: string, aggressive: boolean, declarations: boolean}} param0
 */

const patchTsConfigCore = ({
  oldConfig,
  baseTsConfigLocation,
  aggressive,
  declarations
}, deps = defaultDeps) => {
  const tsParams = { ...(baseTsConfigLocation && {
      baseConfigLocation: baseTsConfigLocation
    })
  };
  const config = declarations ? deps.tsConfigDeclarations(tsParams) : deps.tsConfig(tsParams);
  /** @type {typeof config} */

  const result = aggressive ? config : (0, _deepmerge.default)(oldConfig, config, {
    arrayMerge: (_target, source) => source
  });
  return result;
};

exports.patchTsConfigCore = patchTsConfigCore;
patchTsConfigCore.defaultDeps = defaultDeps;
//# sourceMappingURL=patchTsConfig.js.map